import asyncio
import hmac
import hashlib
import json
import sys
import websockets

async def adjust_gain(uri, password, tx_gain=0, rx_gain=0):
    async with websockets.connect(uri, origin="Test") as websocket:
        rsp = await websocket.recv()
        print(f"< {rsp}")
        data = json.loads(rsp)
        res = hmac.new(
          "{}:{}:{}".format(data['type'], password, data['name']).encode(),
          msg=data['challenge'].encode(),
          digestmod=hashlib.sha256
        ).hexdigest()
        msg = f'{{"message":"authenticate", "res": "{res}"}}'
        await websocket.send(msg)
        print(f"> {msg}")
        rsp = await websocket.recv()
        print(f"< {rsp}")
        if tx_gain:
            msg = f'{{"message":"rf", "tx_gain": {tx_gain}, "rx_gain": {rx_gain} }}'
        else:
            msg = f'{{"message":"rf", }}'
        await websocket.send(msg)
        await websocket.send(msg)
        print(f"> {msg}")
        rsp = await websocket.recv()
        print(f"< {rsp}")

if len(sys.argv) < 3:
    print("Usage: ./adjust-gain.py WS_URL PASSWORD [TX_GAIN RX_GAIN]")
    exit(1)

asyncio.run(adjust_gain(*sys.argv[1:]))
