import asyncio
import hmac
import hashlib
import json
import sys
import time
import websockets

channel_count = 2

async def get_spl(uri, password):
    async with websockets.connect(uri, origin="Test") as websocket:
        rsp = await websocket.recv()
        data = json.loads(rsp)
        res = hmac.new(
          "{}:{}:{}".format(data['type'], password, data['name']).encode(),
          msg=data['challenge'].encode(),
          digestmod=hashlib.sha256
        ).hexdigest()
        msg = f'{{"message":"authenticate", "res": "{res}"}}'
        await websocket.send(msg)
        rsp = await websocket.recv()

        while True:
            l = []
            for i in range(channel_count):
                l.append('{:^17}'.format(f'--P0/TX {i}--'))
            for i in range(channel_count):
                l.append('{:^17}'.format(f'--P0/RX {i}--'))
            print(' '.join(l))
            print(('{:^8} {:^8}'.format('RMS', 'MAX')) * 4)
            for i in range(10):
                time.sleep(1)
                msg = f'{{"message":"stats", "samples": true}}'
                await websocket.send(msg)
                rsp = await websocket.recv()

                samples = json.loads(rsp)['samples']
                l = []
                for i in range(channel_count):
                    tx = samples['tx']
                    l.append('{:^8.3f} {:^8.3f}'.format(tx[i]['rms'], tx[i]['max']))
                for i in range(channel_count):
                    rx = samples['rx']
                    l.append('{:^8.3f} {:^8.3f}'.format(rx[i]['rms'], rx[i]['max']))
                print(' '.join(l))

if len(sys.argv) != 3:
    print("Usage: ./adjust-gain.py WS_URL PASSWORD")
    exit(1)


asyncio.run(get_spl(*sys.argv[1:]))
